maph 1.0.0 High-Performance Memory-Mapped Key-Value Database with O(1) Lookups

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
maph::HybridSlot Struct Reference

`#include <maph_hybrid.hpp>`

Collaboration diagram for maph::HybridSlot:

## Public Member Functions
bool | is_empty () const
bool | is_deleted () const
bool | is_expired () const
bool | is_valid () const

## Public Attributes
std::atomic< uint32_t > | version {0}
uint32_t | key_hash {0}
uint32_t | size {0}
uint32_t | expires_at {0}
char | value [496] {}

## Static Public Attributes
static constexpr size_t | MAX_VALUE_SIZE = 496
static constexpr uint32_t | EMPTY = 0
static constexpr uint32_t | TOMBSTONE = 0xFFFFFFFF

## Detailed Description

Definition at line 24 of file maph_hybrid.hpp.

## Member Function Documentation

## ◆ is_deleted()

bool maph::HybridSlot::is_deleted | ( |  | ) | const
| inline

Definition at line 36 of file maph_hybrid.hpp.

References key_hash, and TOMBSTONE.

Referenced by is_valid(), and maph::HybridMaph::set().

Here is the caller graph for this function:

## ◆ is_empty()

bool maph::HybridSlot::is_empty | ( |  | ) | const
| inline

Definition at line 35 of file maph_hybrid.hpp.

References EMPTY, and key_hash.

Referenced by maph::HybridMaph::get(), is_valid(), and maph::HybridMaph::set().

Here is the caller graph for this function:

## ◆ is_expired()

bool maph::HybridSlot::is_expired | ( |  | ) | const
| inline

Definition at line 37 of file maph_hybrid.hpp.

References expires_at.

Referenced by is_valid().

Here is the caller graph for this function:

## ◆ is_valid()

bool maph::HybridSlot::is_valid | ( |  | ) | const
| inline

Definition at line 42 of file maph_hybrid.hpp.

References is_deleted(), is_empty(), and is_expired().

Referenced by maph::HybridMaph::get(), and maph::HybridMaph::get_static().

Here is the call graph for this function:
Here is the caller graph for this function:

## Member Data Documentation

## ◆ EMPTY

constexpr uint32_t maph::HybridSlot::EMPTY = 0
| static constexpr

Definition at line 32 of file maph_hybrid.hpp.

Referenced by is_empty().

## ◆ expires_at

uint32_t maph::HybridSlot::expires_at {0}

Definition at line 28 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::expire_cleanup(), is_expired(), maph::HybridMaph::set(), and maph::HybridMaph::set_static().

## ◆ key_hash

uint32_t maph::HybridSlot::key_hash {0}

Definition at line 26 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::expire_cleanup(), maph::HybridMaph::get(), maph::HybridMaph::get_static(), is_deleted(), is_empty(), maph::HybridMaph::set(), and maph::HybridMaph::set_static().

## ◆ MAX_VALUE_SIZE

constexpr size_t maph::HybridSlot::MAX_VALUE_SIZE = 496
| static constexpr

Definition at line 31 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::set(), and maph::HybridMaph::set_static().

## ◆ size

uint32_t maph::HybridSlot::size {0}

Definition at line 27 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::get(), maph::HybridMaph::get_static(), maph::HybridMaph::set(), and maph::HybridMaph::set_static().

## ◆ TOMBSTONE

constexpr uint32_t maph::HybridSlot::TOMBSTONE = 0xFFFFFFFF
| static constexpr

Definition at line 33 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::expire_cleanup(), and is_deleted().

## ◆ value

char maph::HybridSlot::value[496] {}

Definition at line 29 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::get(), maph::HybridMaph::get_static(), maph::HybridMaph::set(), and maph::HybridMaph::set_static().

## ◆ version

std::atomic<uint32_t> maph::HybridSlot::version {0}

Definition at line 25 of file maph_hybrid.hpp.

Referenced by maph::HybridMaph::expire_cleanup(), maph::HybridMaph::set(), and maph::HybridMaph::set_static().

The documentation for this struct was generated from the following file:

- include/maph/maph_hybrid.hpp